# 1.3  Overall Structure

이 후의 Section들은 Background에 대한 설명과 세 가지 파트로 나뉘는데, 여기서는 그 Section들에 대한 outline을 제시하고 간단한 overview를 진행합니다.

### Background

Background는 Chapter 2에서 다루게 됩니다. MARL에서 사용되는 formal한 setting과, 필요한 알고리즘, 개념적 지식을 설명합니다. 그 뒤의 내용들을 잘 이해하기 위해 Background의 내용은 확실히 소화하고 넘어가시길 바랍니다.

## Part 1 : Learning to Collaborate

Single agent의 테크닉을 그대로 MARL에 적용한 것을 Naive learning\(NL\) 이라고 합니다. 이 NL에서의 agent는 다른 상황을 모두 정적이라고 가정합니다. NL은 다른 agent에 대해 아무 가정없이 접근한다는 것이 키포인트입니다.\(다른 agent를 environment의 일부분이라고 가정합니다.\) NL은 신기하게도 생각보다 robust하고 좋은 성능을 보이는데, 그렇기에 다른 algorithm의 benchmark로 주로 사용됩니다.

이전에 언급했던 것 처럼 MARL에서의 큰 문제점은 credit assignment 문제인데, 한 agent가 최적의 행동을 하였어도 다른 agent때문에 전체의 reward가 줄어들면, 이러한 최적의 행동을 할 확률이 줄어들게 됩니다.이런 문제를 NL에서는 신경을 못쓰기 때문에 더욱 문제가 됩니다.

### Chapter 3 Counterfactual Multi-Agent Poilicy Gradidents\(COMA\)

Chapter 3에서는 **COMA**에 대해 배웁니다. COMA는 전체적인 state와 모든 agent의 joint action을 볼 수 있는 critic\(centralized critic\)을 가지고 학습을 진행합니다. 이때 baseline으로, 한 agent가 다른 action을 취했을 때의 평균에 대한 추정을 가지고 advantage function을 만듭니다. COMA는 starcraft 환경에서 baseline보다 괜찮은 성능을 보입니다.

### Chapter 4 Multi-Agent Common Knowledge Reinforcement Learning\(MACKRL\)

Chapter 4에서는 MACKRL에 대해 배웁니다. MACKRL에서는 그룹내에서 agent들이 서로 common knowledge를 가지게 되는데, 이는 fully decentralized 상황에서 joint action에 대한 policy 배울 수 있도록 해줍니다.

 그룹의 common knowledge라 함은 모든 agent가 아는 정보이고 모든 agent가 모든 agent끼리 이것을 안다는 것을 아는 상태를 말합니다. 그래서 MACKRL에서 agent는 다른 agent들을 관찰하고, 그럼으로써 그들은 common knowledge를 배우게 된다는 점을 이용합니다. 

MACKRL은 hierarchical controller를 사용하는데, 이 것은 그룹의 agent들에게 joint action을 할당해주거나, 협력해야하는 agent끼리 분할하는 역할을 합니다. 작은 subgroup\(agent 수가 적은\)은 상대적으로 많은 common knowledge를 공유할 것입니다.\(partially observable할 때, agent수가 많을수록 서로 같이 아는 정보가 줄어드므로\) 하지만 이런 많은 정보를 가지고있어도 조직이 작아지므로 조직화된 action은 어려워집니다.\(MACKRL에선 subgroup간의 교류가 없습니다.\) 그러므로 MACKRL controller는 Common knowledge와 subgroup의 조직화된 action사이에 trade off를 배우게 됩니다.

### Chapter 5 Stabilizing Experience Replay

COMA와 MACKRL은 on-policy method입니다. sample efficiency를 위해 off-policy를 사용하는 것을 생각해보았을 때, 주로 off-policy Deep RL은 replay memory를 사용합니다. 하지만 MARL 환경에서는 replay memory에서 data를 뽑는 것 자체가 non-stationary합니다. 왜냐면 같이 존재하는 agent의 policy에 따라 얻게될 reward의 기댓값이 다르기 때문입니다. 이러한 문제를 풀기위해 importance weight과 metadata를 input으로 넣어주는 방법을 사용합니다. meta data는 어느 episode 위치로부터 수집되었는지, 다른 agent들의 policy와 구분될 수 있게 해줍니다.

이 Chapter들은 다음의 논문에 따라 진행됩니다.

* 'Counterfactual Multi-Agent Policy Gradient' Jakob Foerster, et al.
* 'Stabilising Experience replay for deep multi-agent reinforcement learning' Jakob Foerster, et al.
* 'Multi-Agent Common-Knowledge Reinforcement Learning', Christian A Schroeder de Witt, et al.

## Part 2 : Learning to Communicate

지금까지는 agent간의 명확한 communication 방법에 대해 생각해보지 않았습니다. 실제 환경에서 agent는 굉장히 제한된 communication을 할 수 있는 경우가 많습니. Chapter 6 에서는 어떻게 agent가 Cheap-talk 채널만을 사용하면서 communication protocol을 배우는지 배울 것입니다. Cheap-talk이란 environment에서 transition probability나 reward에 영향을 미치지 않으며 소통할 수 있는 message입니다.

Differentiable Inter-Agent Learning\(DIAL\)과 Reinforced Inter-Agent Learning\(RIAL\)을 제안하는데, centralized training동안, RIAL은 단지 메세지를 action space의 일부로, 어떤 message를 보내야할지 배웁니다. 반면에 DIAL은 continuous activation으로써 messages를 모델링하고, 두 agent간에 어떤 message를 보내야 할지에 대해 배우기 위해 gradients를 보냅니다. Chapter 7에서는 Bayesian Action Decoder\(BAD\)를 제안하는데, 이는 public-belief MDP를 도입한 cheap talk channel가 없을 때 사용되는 method입니다. agent가 environment에서 action을 취했을 때, 다른 agent로 부터 관찰됨으로써 communicate될 때 되는 상황에 대해 해결할 수 있습니다. 직접적으로 다른 agent를 관찰하며 그들의 상태를 추론함으로써, BAD는 Hanabi game에서 SOTA를 달성했습니다. 다음과 같은 논문들을 기반으로 쓰여졌습니다.

* 'Learning to communicate with deep multi-agent reinforcement learning' Jakob Foerster,et al.
* 'Bayesian Action Decoder for Deep Multi-Agent Reinforcement Learning' Jakob Foerster,et al.

## Part 3 : Learning to Reciprocate

  
지금까지는 cooperative한 환경에서 team reward를 최대화 하기 위한 방법들에 대해 얘기했습니다. 하지만, 많은 실제 문제에서 agent는 개인의 목적을 최대화하는 데에 목적을 두고 있습니다. 예를 들면, 모든 driver는 자신의 목적지까지 최대한 빨리 도착하는 것을 원하지 전체 도로의 효율성을 따지지 않습니다. Game theory는 이러한 상황에서 최선의 전략을 짜는데 오랜 역사가 있습니다. 여기에는 내쉬 균형\(Nash equilibrium\)이라는 게임이론의 중점적인 개념이있는데, 어떤 agent도 자신이 policy를 바꾼다고 더 나은 return을 받지 못하는 균형상태를 말합니다. 하지만 게임이론에서 내쉬 균형은 계산가능하지만, RL에서는 다릅니다. MARL에서 agent는 environment와의 상호작용에 의존합니다. 반면에 NL은 cooperative한 환경에선 놀랄만큼 잘 동작했지만, general sum에 대해선 문제가 발생할 수 있습니다. 첫번째로, 모든 agent는 그들의 objective를 최대화하는 것은 안정적이지 않고, 둘째로, agent는 상호 응답하는데 실패해 모두가 안좋은 내쉬균형을 이룰 수 있습니다. 다음과 같은 이슈들은 agent를 학습시킬때 다른 agent들을 정적인 환경으로 취급하기 때문입니다. 여기서 Learning with opponent-Learning Awareness\(LOLA\)는 이러한 이슈들을 극복하고 agent들이 높은 reward를 가지는 내쉬균형에 이르도록 돕습니다. 다른 agent들이 정적이라고 가정하는 것 보다, 다른 agent들도 learner라고 가정하고 상대가 행동한 이후의 reward를 최적화하도록 학습합니다. 중요한 것은 이렇게 policy를 만들기 위해선, 상대가 학습 단계도 미분 가능 해야합니다. 이런 학습을 통해 LOLA agents들은 반복적인 prisoner's dilemma에서 tit-for-tat 전략을 발견하는 것을 보였습니다. 한가지 기술적인 어려움은 학습할 때 agent의 높은 차수의 미분값을 구해야하는데 이 것이 environment에서 추정되어야한다는 점입니다. 이를 해결하기 위해 Chapter 9에서는 The Infinitely Differentiable Monte-Carlo Estimator\(DiCE\)를 도입했습다.

* 'Learning with Opponent-Learning Awareness' Jakob N Foerster
* 'DiCE: The Infinitely Differentiable Monte-Carlo Estimator' Jakob N Foerster





### \(1\)Difference reward

reward structure를 정할때, 가장 쉬운 접근은 모든 agent가 system이 받는대로 받는 것 입니다. 하지만 이는 너무 느린 수렴을 보이고, 그래서 여기서는 agent마다 개별 reward를 주는 것에 착안했습니다. agent들은 그들 각자의 reward를 최대화하는 것인데, 중요한 행동을 했을 때, 높은 reward를 주어 전체적인 시스템이 좋은 performance를 보이도록 해야합니다. 

### \(2\)Joint

joint라는 단어가 자주 나오게 되는데 이는, 결합 확률 분포를 생각하면 쉽습니다.결합확률 분포는 확률 변수가 두가지 이상 결합되어있는 분포입니다. 다른 agent의 행동이 stochastic하므로 Joint value를 배우는 것이 정확한 표현입니다.

### reference

* Kagan Tumer and Adrian Agogino. "Distributed Agent-Based Air Traffic Flow Management"\(2007\) 

