# 2.8 Nash Equilibria

다수의 agent가 자신의 reward를 높이려고 할 때,\(General-Sum 문제\) 어떤 metric이 최적의 상태를 만들 수 있는지는 사실 모호합니다. 그렇기 때문에 여기서는 이를 도울 수 있는 하나의 개념을 가지고 오는데 바로 내쉬 균형\(Nash-equilibrium\)입니다.

### Nash-equilibrium

이 아이디어는 어떤 policy set $$ \bold{\pi}^*  $$가 존재할 때, 각자의 agent a가 다른 agent들의 policy $$ \bold{\pi}^{*-a}$$에 대해서 어떤 agent a가 다른 policy를 들고와도 return을 최대화할 수 없는 평형상태를 말하는데 수식적으로 다음과 같습니다.

                                                   $$ \forall a : J^a(\pi^{*a},\bm{\pi}^{*-a} )\geq J^a(\pi^a,\bm{\pi}^{*-a}),\forall{\bm{\pi}}^a$$

확실한 것은 내쉬 균형을 이루는 목표를 가지는 것으로부터 MARL algorithm을 전개해나가는 것은 괜찮은 전략으로 보입니다. 그러나, 내쉬 균형은 여러개가 존재할 수도, 없을 수도 있습니다. 심지어 모두가 별로인 상태에서의 내쉬 균형으로도 균형이 맞춰질 수도 있습니다. 이러한 내쉬 균형은 MARL algorithm을 local minima에 빠뜨리도록 할 수 있습니다.

보통 게임이론에서 내쉬 균형은 알려졌거나 쉽게 구할 수 있는데, MARL은 직접 environment와 상호작용하면서 배워야합니다.

### best response

주어진 policy 집합 $$ \bold{\pi}^{-a}$$에 대, $$ \bold{\pi}^{-a}$$에 대응하는 가장 좋은 policy $$\hat{\pi}(\bold{\pi}^{-a})$$는 $$ {\bold{J}^a(\pi^a,\bold{\pi}^{-a})}$$를 maximize하는 $${\pi}^{a}$$입니다.

                                                         $$ \hat{\pi}(\bm{\pi}^{-a}) = \mathrm{argmax}_{\pi^a}{\bold{J}^a(\pi^a,\bm{\pi}^{-a})}$$

